diff --git a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
index 52109ecd..349c9a00 100644
--- a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
+++ b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
@@ -12,6 +12,8 @@ define('tools.querytool', [
   'sources/selection/xcell_selection_model',
   'sources/selection/set_staged_rows',
   'sources/sqleditor_utils',
+  'sources/sqleditor/execute_query',
+  'sources/sqleditor/is_new_transaction_required',
   'sources/history/index.js',
   'sources/../jsx/history/query_history',
   'react', 'react-dom',
@@ -28,7 +30,8 @@ define('tools.querytool', [
 ], function(
   babelPollyfill, gettext, url_for, $, _, S, alertify, pgAdmin, Backbone, codemirror,
   pgExplain, GridSelector, ActiveCellCapture, clipboard, copyData, RangeSelectionHelper, handleQueryOutputKeyboardEvent,
-  XCellSelectionModel, setStagedRows, SqlEditorUtils, HistoryBundle, queryHistory, React, ReactDOM,
+  XCellSelectionModel, setStagedRows, SqlEditorUtils, ExecuteQuery, transaction,
+  HistoryBundle, queryHistory, React, ReactDOM,
   keyboardShortcuts, queryToolActions, Datagrid) {
   /* Return back, this has been called more than once */
   if (pgAdmin.SqlEditor)
@@ -43,12 +46,6 @@ define('tools.querytool', [
 
   var is_query_running = false;
 
-  var is_new_transaction_required = function(xhr) {
-    return xhr.status == 404 && xhr.responseJSON &&
-                xhr.responseJSON.info &&
-                xhr.responseJSON.info == 'DATAGRID_TRANSACTION_REQUIRED';
-  };
-
   // Defining Backbone view for the sql grid.
   var SQLEditorView = Backbone.View.extend({
     initialize: function(opts) {
@@ -485,7 +482,7 @@ define('tools.querytool', [
                 if (pgAdmin.Browser.UserManagement.is_pga_login_required(e)) {
                   return pgAdmin.Browser.UserManagement.pga_login();
                 }
-                if(is_new_transaction_required(e)) {
+                if(transaction.is_new_transaction_required(e)) {
                   return self.init_transaction();
                 }
               },
@@ -2188,7 +2185,7 @@ define('tools.querytool', [
               pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_run_query', []);
               self.init_transaction();
             }
@@ -2256,74 +2253,8 @@ define('tools.querytool', [
        * 'Success' then call the render method to render the data.
        */
       _poll: function() {
-        var self = this;
-
-        setTimeout(
-          function() {
-            $.ajax({
-              url: url_for('sqleditor.poll', {
-                'trans_id': self.transId,
-              }),
-              method: 'GET',
-              success: function(res) {
-                if (res.data.status === 'Success') {
-                  self.trigger(
-                    'pgadmin-sqleditor:loading-icon:message',
-                    gettext('Loading data from the database server and rendering...')
-                  );
-
-                  self.call_render_after_poll(res.data);
-                } else if (res.data.status === 'Busy') {
-                  // If status is Busy then poll the result by recursive call to the poll function
-                  self._poll();
-                  is_query_running = true;
-                  if (res.data.result) {
-                    self.update_msg_history(res.data.status, res.data.result, false);
-                  }
-                } else if (res.data.status === 'NotConnected') {
-                  self.trigger('pgadmin-sqleditor:loading-icon:hide');
-                  // Enable/Disable query tool button only if is_query_tool is true.
-                  if (self.is_query_tool) {
-                    self.disable_tool_buttons(false);
-                    $('#btn-cancel-query').prop('disabled', true);
-                  }
-                  self.update_msg_history(false, res.data.result, true);
-                } else if (res.data.status === 'Cancel') {
-                  self.trigger('pgadmin-sqleditor:loading-icon:hide');
-                  self.update_msg_history(false, 'Execution Cancelled!', true);
-                }
-              },
-              error: function(e) {
-                // Enable/Disable query tool button only if is_query_tool is true.
-                self.resetQueryHistoryObject(self);
-                self.trigger('pgadmin-sqleditor:loading-icon:hide');
-                if (self.is_query_tool) {
-                  self.disable_tool_buttons(false);
-                  $('#btn-cancel-query').prop('disabled', true);
-                }
-
-                if (e.readyState == 0) {
-                  self.update_msg_history(false,
-                    gettext('Not connected to the server or the connection to the server has been closed.')
-                  );
-                  return;
-                }
-
-                if (pgAdmin.Browser.UserManagement.is_pga_login_required(e)) {
-                  return pgAdmin.Browser.UserManagement.pga_login();
-                }
-
-                var msg = e.responseText;
-                if (e.responseJSON != undefined &&
-                  e.responseJSON.errormsg != undefined)
-                  msg = e.responseJSON.errormsg;
-
-                self.update_msg_history(false, msg);
-                // Highlight the error in the sql panel
-                self._highlight_error(msg);
-              },
-            });
-          }, self.POLL_FALLBACK_TIME());
+        const executeQuery = new ExecuteQuery.ExecuteQuery(this, pgAdmin.Browser.UserManagement);
+        executeQuery.delayedPoll(this);
       },
 
       /* This function is used to create the backgrid columns,
@@ -2941,7 +2872,7 @@ define('tools.querytool', [
                 pgAdmin.Browser.UserManagement.pga_login();
               }
 
-              if(is_new_transaction_required(e)) {
+              if(transaction.is_new_transaction_required(e)) {
                 self.save_state('_save', [view, controller, save_as]);
                 self.init_transaction();
               }
@@ -3267,7 +3198,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_show_filter', []);
               return self.init_transaction();
             }
@@ -3356,7 +3287,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_include_filter', []);
               return self.init_transaction();
             }
@@ -3447,7 +3378,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_exclude_filter', []);
               return self.init_transaction();
             }
@@ -3517,7 +3448,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_remove_filter', []);
               return self.init_transaction();
             }
@@ -3592,7 +3523,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_apply_filter', []);
               return self.init_transaction();
             }
@@ -3747,7 +3678,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_set_limit', []);
               return self.init_transaction();
             }
@@ -3795,10 +3726,7 @@ define('tools.querytool', [
       // and execute the query.
       execute: function(explain_prefix) {
         var self = this,
-          sql = '',
-          url = url_for('sqleditor.query_tool_start', {
-            'trans_id': self.transId,
-          });
+          sql = '';
 
         self.has_more_rows = false;
         self.fetching_rows = false;
@@ -3812,109 +3740,8 @@ define('tools.querytool', [
         else
           sql = self.gridView.query_tool_obj.getValue();
 
-        // If it is an empty query, do nothing.
-        if (sql.length <= 0) return;
-
-        self.trigger(
-          'pgadmin-sqleditor:loading-icon:show',
-          gettext('Initializing query execution...')
-        );
-
-        $('#btn-flash').prop('disabled', true);
-
-        if (explain_prefix != undefined &&
-          !S.startsWith(sql.trim().toUpperCase(), 'EXPLAIN')) {
-          sql = explain_prefix + ' ' + sql;
-        }
-
-        self.query_start_time = new Date();
-        self.query = sql;
-        self.rows_affected = 0;
-        self._init_polling_flags();
-        self.disable_tool_buttons(true);
-        $('#btn-cancel-query').prop('disabled', false);
-
-        if (arguments.length > 0 &&
-          arguments[arguments.length - 1] == 'connect') {
-          url += '?connect=1';
-        }
-
-        $.ajax({
-          url: url,
-          method: 'POST',
-          contentType: 'application/json',
-          data: JSON.stringify(sql),
-          success: function(res) {
-            // Remove marker
-            if (self.gridView.marker) {
-              self.gridView.marker.clear();
-              delete self.gridView.marker;
-              self.gridView.marker = null;
-
-              // Remove already existing marker
-              self.gridView.query_tool_obj.removeLineClass(self.marked_line_no, 'wrap', 'CodeMirror-activeline-background');
-            }
-
-            if (res.data.status) {
-              self.trigger(
-                'pgadmin-sqleditor:loading-icon:message',
-                gettext('Waiting for the query execution to complete...')
-              );
-
-              self.can_edit = res.data.can_edit;
-              self.can_filter = res.data.can_filter;
-              self.info_notifier_timeout = res.data.info_notifier_timeout;
-
-              // If status is True then poll the result.
-              self._poll();
-            } else {
-              self.trigger('pgadmin-sqleditor:loading-icon:hide');
-              self.disable_tool_buttons(false);
-              $('#btn-cancel-query').prop('disabled', true);
-              self.update_msg_history(false, res.data.result);
-
-              // Highlight the error in the sql panel
-              self._highlight_error(res.data.result);
-            }
-          },
-          error: function(e) {
-            self.trigger('pgadmin-sqleditor:loading-icon:hide');
-            self.disable_tool_buttons(false);
-            $('#btn-cancel-query').prop('disabled', true);
-
-            if (e.readyState == 0) {
-              self.update_msg_history(false,
-                gettext('Not connected to the server or the connection to the server has been closed.')
-              );
-              return;
-            }
-
-            if (pgAdmin.Browser.UserManagement.is_pga_login_required(e)) {
-              self.save_state('execute', [explain_prefix]);
-              pgAdmin.Browser.UserManagement.pga_login();
-            }
-
-            if(is_new_transaction_required(e)) {
-              self.save_state('execute', [explain_prefix]);
-              self.init_transaction();
-            }
-            var msg = e.responseText;
-            if (e.responseJSON != undefined) {
-              if(e.responseJSON.errormsg != undefined) {
-                msg = e.responseJSON.errormsg;
-              }
-
-              if(e.status == 503 && e.responseJSON.info != undefined &&
-                  e.responseJSON.info == 'CONNECTION_LOST') {
-                setTimeout(function() {
-                  self.save_state('execute', [explain_prefix]);
-                  self.handle_connection_lost(false, e);
-                });
-              }
-            }
-            self.update_msg_history(false, msg);
-          },
-        });
+        const executeQuery = new ExecuteQuery.ExecuteQuery(this, pgAdmin.Browser.UserManagement);
+        executeQuery.execute(sql, explain_prefix);
       },
 
       /* This function is used to highlight the error line and
@@ -4078,7 +3905,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_auto_rollback', []);
               self.init_transaction();
             }
@@ -4139,7 +3966,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_auto_commit', []);
               return self.init_transaction();
             }
@@ -4201,7 +4028,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_explain_verbose', []);
               return self.init_transaction();
             }
@@ -4250,7 +4077,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_explain_costs', []);
               return self.init_transaction();
             }
@@ -4298,7 +4125,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_explain_buffers', []);
               return self.init_transaction();
             }
@@ -4345,7 +4172,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('_explain_timing', []);
               return self.init_transaction();
             }
@@ -4379,6 +4206,10 @@ define('tools.querytool', [
         return is_query_running;
       },
 
+      setIsQueryRunning: function(value) {
+        is_query_running = value;
+      },
+
       /*
        * This function get explain options and auto rollback/auto commit
        * values from preferences
@@ -4455,7 +4286,7 @@ define('tools.querytool', [
               return pgAdmin.Browser.UserManagement.pga_login();
             }
 
-            if(is_new_transaction_required(e)) {
+            if(transaction.is_new_transaction_required(e)) {
               self.save_state('get_preferences', []);
               return self.init_transaction();
             }
diff --git a/web/pgadmin/tools/sqleditor/tests/__init__.py b/web/pgadmin/tools/sqleditor/tests/__init__.py
new file mode 100644
index 00000000..590026ad
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/tests/__init__.py
@@ -0,0 +1,8 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
diff --git a/web/pgadmin/tools/sqleditor/tests/test_explain_plan_templates.py b/web/pgadmin/tools/sqleditor/tests/test_explain_plan_templates.py
new file mode 100644
index 00000000..ab018788
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/tests/test_explain_plan_templates.py
@@ -0,0 +1,152 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import os
+
+from flask import Flask, render_template
+from jinja2 import FileSystemLoader
+
+from pgadmin import VersionedTemplateLoader
+from pgadmin.utils.route import BaseTestGenerator
+
+
+class TestExplainPlanTemplates(BaseTestGenerator):
+    scenarios = [
+        (
+            'When rendering Postgres 9.0 template, '
+            'when passing all parameters,'
+            'it returns the explain plan with all parameters',
+            dict(
+                template_path=os.path.join('sqleditor', 'sql', 'default', 'explain_plan.sql'),
+                input_parameters=dict(
+                    sql='select * from places',
+                    format='xml',
+                    analyze=True,
+                    verbose=True,
+                    costs=False,
+                    buffers=True
+                ),
+                sql_statement='select * from places',
+                expected_return_value='EXPLAIN '
+                                      '(  FORMAT XML,  ANALYZE True,  VERBOSE True,  '
+                                      'COSTS False,  BUFFERS True) select * from places'
+            )
+        ),
+        (
+            'When rendering Postgres 9.0 template, '
+            'when not all parameters are present,'
+            'it returns the explain plan with the present parameters',
+            dict(
+                template_path=os.path.join('sqleditor', 'sql', 'default', 'explain_plan.sql'),
+                input_parameters=dict(
+                    sql='select * from places',
+                    format='json',
+                    buffers=True
+                ),
+                sql_statement='select * from places',
+                expected_return_value='EXPLAIN '
+                                      '(  FORMAT JSON,  BUFFERS True) select * from places'
+            )
+        ),
+        (
+            'When rendering Postgres 9.2 template, '
+            'when timing is present,'
+            'it returns the explain plan with timing',
+            dict(
+                template_path=os.path.join('sqleditor', 'sql', '9.2_plus', 'explain_plan.sql'),
+                input_parameters=dict(
+                    sql='select * from places',
+                    format='json',
+                    buffers=True,
+                    timing=False
+                ),
+                sql_statement='select * from places',
+                expected_return_value='EXPLAIN '
+                                      '(  FORMAT JSON,  TIMING False,  BUFFERS True) select * from places'
+            )
+        ),
+        (
+            'When rendering Postgres 10 template, '
+            'when summary is present,'
+            'it returns the explain plan with summary',
+            dict(
+                template_path=os.path.join('sqleditor', 'sql', '10_plus', 'explain_plan.sql'),
+                input_parameters=dict(
+                    sql='select * from places',
+                    format='yaml',
+                    buffers=True,
+                    timing=False,
+                    summary=True
+                ),
+                sql_statement='select * from places',
+                expected_return_value='EXPLAIN '
+                                      '(  FORMAT YAML,  TIMING False,  SUMMARY True,  BUFFERS True) select * from places'
+            )
+        ),
+        (
+            'When rendering GreenPlum 5.3 template, '
+            'when all parameters are present,'
+            'it returns the explain without parameters',
+            dict(
+                template_path=os.path.join('sqleditor', 'sql', 'gpdb_5.0_plus', 'explain_plan.sql'),
+                input_parameters=dict(
+                    sql='select * from places',
+                    format='json',
+                    buffers=True
+                ),
+                sql_statement='select * from places',
+                expected_return_value='EXPLAIN select * from places'
+            )
+        ),
+        (
+            'When rendering GreenPlum 5.3 template, '
+            'when analyze is true,'
+            'it returns the explain analyze',
+            dict(
+                template_path=os.path.join('sqleditor', 'sql', 'gpdb_5.0_plus', 'explain_plan.sql'),
+                input_parameters=dict(
+                    sql='select * from places',
+                    analyze=True
+                ),
+                sql_statement='select * from places',
+                expected_return_value='EXPLAIN ANALYZE select * from places'
+            )
+        ),
+        (
+            'When rendering GreenPlum 5.3 template, '
+            'when analyze is false,'
+            'it returns the only explain',
+            dict(
+                template_path=os.path.join('sqleditor', 'sql', 'gpdb_5.0_plus', 'explain_plan.sql'),
+                input_parameters=dict(
+                    sql='select * from places',
+                    analyze=False
+                ),
+                sql_statement='select * from places',
+                expected_return_value='EXPLAIN select * from places'
+            )
+        ),
+    ]
+
+    def setUp(self):
+        self.loader = VersionedTemplateLoader(FakeApp())
+
+    def runTest(self):
+        with FakeApp().app_context():
+            result = render_template(self.template_path, **self.input_parameters)
+            self.assertEqual(
+                str(result).replace("\n", ""), self.expected_return_value)
+
+
+class FakeApp(Flask):
+    def __init__(self):
+        super(FakeApp, self).__init__("")
+        self.jinja_loader = FileSystemLoader(
+            os.path.dirname(os.path.realpath(__file__)) + "/../templates"
+        )
diff --git a/web/pgadmin/tools/sqleditor/tests/test_extract_sql_from_network_parameters.py b/web/pgadmin/tools/sqleditor/tests/test_extract_sql_from_network_parameters.py
new file mode 100644
index 00000000..c4e002cc
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/tests/test_extract_sql_from_network_parameters.py
@@ -0,0 +1,59 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+from werkzeug.datastructures import ImmutableMultiDict
+
+from pgadmin.tools.sqleditor import extract_sql_from_network_parameters
+from pgadmin.utils.route import BaseTestGenerator
+
+
+class ExtractSQLFromNetworkParametersTest(BaseTestGenerator):
+    """
+    This class validates the change password functionality
+    by defining change password scenarios; where dict of
+    parameters describes the scenario appended by test name.
+    """
+
+    scenarios = [
+        ('Single string in the payload', dict(
+            request_strigified_data='"some sql"',
+            request_arguments=ImmutableMultiDict(),
+            request_form_data=ImmutableMultiDict(),
+
+            expected_result=dict(sql='some sql', explain_plan=None)
+        )),
+        ('Payload that requests explain plan using json', dict(
+            request_strigified_data='{"sql": "some sql", "explain_plan": {"format": "json", "analyze": false, "verbose": false, "costs": false, "buffers": false, "timing": false}}',
+            request_arguments=ImmutableMultiDict(),
+            request_form_data=ImmutableMultiDict(),
+
+            expected_result=dict(
+                sql='some sql',
+                explain_plan=dict(
+                    format='json',
+                    analyze=False,
+                    verbose=False,
+                    buffers=False,
+                    costs=False,
+                    timing=False
+                )
+            )
+        ))
+    ]
+
+    def runTest(self):
+        """Check correct function is called to handle to run query."""
+
+        result = extract_sql_from_network_parameters(
+            self.request_strigified_data,
+            self.request_arguments,
+            self.request_form_data
+        )
+
+        self.assertEquals(result, self.expected_result)
diff --git a/web/pgadmin/tools/sqleditor/tests/test_start_query_tool.py b/web/pgadmin/tools/sqleditor/tests/test_start_query_tool.py
new file mode 100644
index 00000000..5e2752ae
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/tests/test_start_query_tool.py
@@ -0,0 +1,38 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+import sys
+
+from pgadmin.utils.route import BaseTestGenerator
+from pgadmin.tools.sqleditor import StartRunningQuery
+
+if sys.version_info < (3, 3):
+    from mock import patch, ANY
+else:
+    from unittest.mock import patch, ANY
+
+
+class StartQueryTool(BaseTestGenerator):
+    """
+    Ensures that the call to the backend to start running a query
+    calls the needed functions
+    """
+
+    @patch('pgadmin.tools.sqleditor.extract_sql_from_network_parameters')
+    def runTest(self, extract_sql_from_network_parameters_mock):
+        """Check correct function is called to handle to run query."""
+
+        extract_sql_from_network_parameters_mock.return_value = 'transformed sql'
+
+        with patch.object(StartRunningQuery, 'execute', return_value='some result') as StartRunningQuery_execute_mock:
+            response = self.tester.post('/sqleditor/query_tool/start/1234', data='"some sql statement"')
+
+            self.assertEquals(response.status, '200 OK')
+            self.assertEquals(response.data, 'some result')
+            StartRunningQuery_execute_mock.assert_called_with('transformed sql', 1234, ANY)
+            extract_sql_from_network_parameters_mock.assert_called_with('"some sql statement"', ANY, ANY)
diff --git a/web/pgadmin/tools/sqleditor/utils/__init__.py b/web/pgadmin/tools/sqleditor/utils/__init__.py
new file mode 100644
index 00000000..3626b658
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/utils/__init__.py
@@ -0,0 +1,14 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+from .constant_definition import *
+from .is_begin_required import is_begin_required
+from .update_session_grid_transaction import update_session_grid_transaction
+from .start_running_query import *
+from .apply_explain_plan_wrapper import *
diff --git a/web/pgadmin/tools/sqleditor/utils/apply_explain_plan_wrapper.py b/web/pgadmin/tools/sqleditor/utils/apply_explain_plan_wrapper.py
new file mode 100644
index 00000000..84e478de
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/utils/apply_explain_plan_wrapper.py
@@ -0,0 +1,24 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+"""Apply Explain plan wrapper to sql object."""
+from flask import render_template
+
+from pgadmin.utils.compile_template_name import compile_template_name
+
+
+def apply_explain_plan_wrapper_if_needed(manager, sql):
+    if 'explain_plan' in sql and sql['explain_plan']:
+        explain_plan = sql['explain_plan']
+        ver = manager.version
+        server_type = manager.server_type
+        template_path = compile_template_name('sqleditor/sql', 'explain_plan.sql', server_type, ver)
+        return render_template(template_path, sql=sql['sql'], **explain_plan)
+    else:
+        return sql['sql']
diff --git a/web/pgadmin/tools/sqleditor/utils/constant_definition.py b/web/pgadmin/tools/sqleditor/utils/constant_definition.py
new file mode 100644
index 00000000..44c7ecb7
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/utils/constant_definition.py
@@ -0,0 +1,32 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+"""Definition of constants for SQLEditor."""
+
+# Async Constants
+ASYNC_OK = 1
+ASYNC_READ_TIMEOUT = 2
+ASYNC_WRITE_TIMEOUT = 3
+ASYNC_NOT_CONNECTED = 4
+ASYNC_EXECUTION_ABORTED = 5
+
+# Transaction status constants
+TX_STATUS_IDLE = 0
+TX_STATUS__ACTIVE = 1
+TX_STATUS_INTRANS = 2
+TX_STATUS_INERROR = 3
+
+# Connection status codes mapping
+CONNECTION_STATUS_MESSAGE_MAPPING = dict({
+    0: 'The session is idle and there is no current transaction.',
+    1: 'A command is currently in progress.',
+    2: 'The session is idle in a valid transaction block.',
+    3: 'The session is idle in a failed transaction block.',
+    4: 'The connection with the server is bad.'
+})
